#
# n_lottery_probability.py
#
# by zhuo  2023.04.15

import numpy as np

N = 4
upto = 30

#### initialization

def nlottery_comp_prob( N, upto ):
    ## initial values of u
    u = np.zeros( N, dtype=float )
    u[0] = 1.0

    ## initial values of the matrix A
    A = np.zeros( (N,N), dtype=float )
    for i in range( 0, N ):
        A[i][i] = float(i+1)
    for i in range( 0, N-1 ):
        A[i+1][i] = float(N-1-i)

    #### calculation
    nall = 1.0
    ns = []
    ps = []
    for j in range( 0, upto ):
        n = j+1
        p = u[-1] / nall
        ns.append( n )
        ps.append( p )
        u = A @ u
        nall *= float(N)
    return( ns, ps )


#### plot
from matplotlib import pyplot as plt
plt.rcParams['font.family'] = 'MS Gothic'

n_from = 2
n_below = 9

for cnt in range( 0, upto+1 ):
    print( "%d" % cnt, end="\t" )
print( "\n" )

for n in range( n_from, n_below ):
    ns,ps = nlottery_comp_prob( n, upto )
    plt.plot( ns, ps, label="%d種類" % n )

    print( "%d" % n, end="\t" )
    for p in ps:
        print( "%8.6f" % p, end="\t" )
    print( "\n" )

plt.grid()
plt.title( "N種類のランダムくじをコンプする確率(N=%d...%d)" % (n_from, n_below-1) )
plt.xlabel( "引く回数" )
plt.ylabel( "コンプの確率" )
plt.legend()
plt.show()
